/******************************************************************************
    Program url2data, builds database from url address:
    - recursive.c - source file for recursive retrieving url address

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "url2data.h"

short int geturlloc(char *UrlLoc);/* add url location to database */
short int InFile(char *location);/* test if location is in file */
short int ExtOk(char *Loc);/* test if extension match */

void go_recursive(void)/* go recursive retrieve */
{
FILE *f;
unsigned long size;
unsigned char lin[1025];

E_OPT=true;size=0;/* set to find if there is alredy link */
do{/* repeat to read urls */
 f=fopen(recdbase,"r");fseek(f,size,SEEK_SET);/* open file and go to next url */
 lin[0]=0;fgets(lin,1025,f);/* reset and load line */
 size=ftell(f);fclose(f);/* get last position */
 if(strlen(lin)>3){/* ok there is url */
  lin[strlen(lin)-1]=0;/* remove new line char */
  geturlloc(lin);/* retrieve url */
 }/* end if lin > 3 */
}while(lin[0]!=0);/* repeat until lin isn't empty */
}/* end go_recursive() */

void parse_url(char UrlBegin[1024])/* extract urls from source */
{
FILE *f,*g;
char exetxt[2048];
unsigned long size;
int i;

printf("\r%79s\rRetrieving recursive url locations..."," ");fflush(NULL);
exetxt[0]=0;sprintf(exetxt,"lynx %s \"%s\" > %s",DUMPLNK,UrlBegin,logdbase);
system(exetxt);/* execute template for dumping urls */
printf(" Done.");fflush(NULL);
i=strlen(UrlBegin)-1;while(UrlBegin[i]!='/') i--;UrlBegin[i]=0;/* extract Url */

f=fopen(logdbase,"rb");exetxt[0]=0;/* open file */
fseek(f,0L,SEEK_END);size=ftell(f)-1;rewind(f);/* reset location */
while(!feof(f)){/* scan for Reference */
 exetxt[0]=0;fgets(exetxt,2048,f);
 if(strcmp(exetxt,"References\n")==0) /* found line, mark it */
  size=ftell(f);/* get location */
}/* end while thru file */

fseek(f,size,SEEK_SET);/* set to last known location */
do{/* go to end of file */
 exetxt[0]=0;fgets(exetxt,2048,f);/* read line */
 if(strlen(exetxt)>3){/* convert only links */
  i=4;/* skipp spaces */
  while(exetxt[i]!=' ') i++;i++;size=i;/* go to beggining of url */
  while( (exetxt[i]!='\n')&&(exetxt[i]!=0) ){/* go to end of line */
   exetxt[i-size]=exetxt[i];i++;}/* end while */
  exetxt[i-size]=0;
  if(strncmp(exetxt,UrlBegin,strlen(UrlBegin))==0){/* all ok */
   i=strlen(exetxt)-1;while( (exetxt[i]!='/')&&(exetxt[i]!='#')&&(i>0) ) i--;
   if(exetxt[i]=='#') exetxt[i]=0;/* skip marcation for chapter */
   if(!ExtOk(exetxt)) exetxt[0]=0;/* extension fail remove location */
   if( !InFile(exetxt)&&(exetxt[0]!=0) ){/* ok link isn't in file */
    g=fopen(recdbase,"a");/* open file for update */
    fprintf(g,"%s\n",exetxt);fclose(g);
   }/* end if InFile */
  }/* end update url list */
 }/* end if links */
}while(!feof(f));/* end while */
fclose(f);/* close file */  
}/* end parse_url() */
