/******************************************************************************
    Program url2data, builds database from url address:
    - url2data.h - header file for all source files, defined public variable.

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#ifndef true /* define boolean type */
#define true 1
#define false 0
#endif

/* Location for configuration file */
#define CONF_FILE "./url2data.conf"

/* variable for extension in recursive search */
char DEF_EXT[512];

/* variable for options */
short int D_OPT,E_OPT,F_OPT,H_OPT,R_OPT,U_OPT,L_OPT;

/* base variable for database, url and file of url file */
char database[512],url_file_adr[1024],tmploc[512],date[80];
unsigned char descr[160];/* variable for description */
/* variable for recursive url list file, log location */
char recdbase[512],logdbase[512],fixhtml[512];

/* define lynx check parametars */
#define DUMPINFO "-mime_header -dump -head -startfile_ok"
#define DUMPLNK "-dump -force_html"
#define DUMPSRC "-source"
#define DUMPURL "-dump -nolist -force_html"
