/******************************************************************************
    Program url2data, builds database from url address:
    - filedump.c - source file for reading list file and dumping url from list

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <ctype.h>

#include "url2data.h"

short int geturlloc(char *UrlLoc);

void dumpfromfile(void)
{
FILE *f;
char lin[1024];

f=fopen(url_file_adr,"rt");/* open file for reading */
while(!feof(f)){/* go thru file */
 lin[0]=0;fgets(lin,1024,f);lin[strlen(lin)-1]=0;/* read line from file */
 if(lin[0]!=0) geturlloc(lin);/* read url */
}/* end while feof */
}

short int InFile(char *location)/* test if location is in file */
{
FILE *f;
unsigned char lin[1025];
short int test;

test=false;f=fopen(recdbase,"r");/* reset variable and open file */
while( !feof(f)&&!test ){/* go thru file */
 lin[0]=0;fgets(lin,1025,f);/* reset and load line */
 lin[strlen(lin)-1]=0;/* remove new line char */
 if(strcmp(location,lin)==0) test=true;
}/* end while */
fclose(f);/* close file */
return(test);
}/* end InFile() */

short int ExtOk(char *Loc)/* test if extension match */
{
short int test;
int Lf,Ef,El,i;

test=false;
Lf=strlen(Loc)-1;while( (Loc[Lf]!='/')&&(Loc[Lf]!='.')&&(Lf>0) ) Lf--;/* ext */
if(Loc[Lf]=='.'){/* ok here is extension */
 El=0;/* reset variable */
 while( !test&&(El<strlen(DEF_EXT)) ){/* scan ext line */
  Ef=El;while( (DEF_EXT[El]!=' ')&&(DEF_EXT[El]!=0)&&(El<strlen(DEF_EXT)) )El++;
  test=true;/* set rezult */
  if( (strlen(Loc)-Lf)!=(El-Ef) ) test=false;/* not the same size */
  for(i=0;(i<El-Ef)&&test;i++){/* compare extension */
   if(tolower(Loc[Lf+i])!=tolower(DEF_EXT[Ef+i])) test=false;/* not that */
  }/* end for i */
  El++;/* go to next extension */
 }/* end while */
}else test=true;/* no extension, it culd be directory */
return(test);
}/* end ExtOk() */
